remote-hg: adjust to hg 1.9
[git/dscho.git] / git-submodule.sh
blobefb0cfdfe93faeddf54d06fbb72f42cbdfdc7f4c
1 #!/bin/sh
3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15 OPTIONS_SPEC=
16 . git-sh-setup
17 . git-sh-i18n
18 . git-parse-remote
19 require_work_tree
21 command=
22 branch=
23 force=
24 reference=
25 cached=
26 recursive=
27 init=
28 files=
29 nofetch=
30 update=
31 prefix=
33 # Resolve relative url by appending to parent's url
34 resolve_relative_url ()
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 remoteurl=$(pwd) # the repository is its own authoritative upstream
39 url="$1"
40 remoteurl=${remoteurl%/}
41 sep=/
42 while test -n "$url"
44 case "$url" in
45 ../*)
46 url="${url#../}"
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
58 esac
60 ./*)
61 url="${url#./}"
64 break;;
65 esac
66 done
67 echo "$remoteurl$sep${url%/}"
71 # Get submodule info for registered submodules
72 # $@ = path to limit submodule list
74 module_list()
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
89 next;
91 print "$_\n";
97 # Map submodule path to submodule name
99 # $1 = path
101 module_name()
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
107 test -z "$name" &&
108 die "$(modulepath=$path eval_gettext "No submodule mapping found in .gitmodules for path '\$modulepath'")"
109 echo "$name"
113 # Clone a submodule
115 # Prior to calling, cmd_update checks that a possibly existing
116 # path is not a git repository.
117 # Likewise, cmd_add checks that path does not exist at all,
118 # since it is the location of a new submodule.
120 module_clone()
122 path=$1
123 url=$2
124 reference="$3"
125 quiet=
126 if test -n "$GIT_QUIET"
127 then
128 quiet=-q
131 gitdir=
132 gitdir_base=
133 name=$(module_name "$path" 2>/dev/null)
134 test -n "$name" || name="$path"
135 base_name=$(dirname "$name")
137 gitdir=$(git rev-parse --git-dir)
138 gitdir_base="$gitdir/modules/$base_name"
139 gitdir="$gitdir/modules/$name"
141 if test -d "$gitdir"
142 then
143 mkdir -p "$path"
144 rm -f "$gitdir/index"
145 else
146 mkdir -p "$gitdir_base"
147 git clone $quiet -n ${reference:+"$reference"} \
148 --separate-git-dir "$gitdir" "$url" "$path" ||
149 die "$(modulepath=$path eval_gettext "Clone of '\$url' into submodule path '\$modulepath' failed")"
152 a=$(cd "$gitdir" && pwd)/
153 b=$(cd "$path" && pwd)/
154 # normalize Windows-style absolute paths to POSIX-style absolute paths
155 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
156 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
157 # Remove all common leading directories after a sanity check
158 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
159 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
161 while test "${a%%/*}" = "${b%%/*}"
163 a=${a#*/}
164 b=${b#*/}
165 done
166 # Now chop off the trailing '/'s that were added in the beginning
167 a=${a%/}
168 b=${b%/}
170 rel=$(echo $b | sed -e 's|[^/]*|..|g')
171 echo "gitdir: $rel/$a" >"$path/.git"
173 rel=$(echo $a | sed -e 's|[^/]*|..|g')
174 (clear_local_git_env; cd "$path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
178 # Add a new submodule to the working tree, .gitmodules and the index
180 # $@ = repo path
182 # optional branch is stored in global branch variable
184 cmd_add()
186 # parse $args after "submodule ... add".
187 while test $# -ne 0
189 case "$1" in
190 -b | --branch)
191 case "$2" in '') usage ;; esac
192 branch=$2
193 shift
195 -f | --force)
196 force=$1
198 -q|--quiet)
199 GIT_QUIET=1
201 --reference)
202 case "$2" in '') usage ;; esac
203 reference="--reference=$2"
204 shift
206 --reference=*)
207 reference="$1"
208 shift
211 shift
212 break
215 usage
218 break
220 esac
221 shift
222 done
224 repo=$1
225 path=$2
227 if test -z "$path"; then
228 path=$(echo "$repo" |
229 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
232 if test -z "$repo" -o -z "$path"; then
233 usage
236 # assure repo is absolute or relative to parent
237 case "$repo" in
238 ./*|../*)
239 # dereference source url relative to parent's url
240 realrepo=$(resolve_relative_url "$repo") || exit
242 *:*|/*)
243 # absolute url
244 realrepo=$repo
247 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
249 esac
251 # normalize path:
252 # multiple //; leading ./; /./; /../; trailing /
253 path=$(printf '%s/\n' "$path" |
254 sed -e '
255 s|//*|/|g
256 s|^\(\./\)*||
257 s|/\./|/|g
258 :start
259 s|\([^/]*\)/\.\./||
260 tstart
261 s|/*$||
263 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
264 die "$(modulepath=$path eval_gettext "'\$modulepath' already exists in the index")"
266 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
267 then
268 cat >&2 <<EOF
269 The following path is ignored by one of your .gitignore files:
270 $(modulepath=$path eval_gettextln "\$modulepath")
271 Use -f if you really want to add it.
273 exit 1
276 # perhaps the path exists and is already a git repo, else clone it
277 if test -e "$path"
278 then
279 if test -d "$path"/.git -o -f "$path"/.git
280 then
281 modulepath=$path eval_gettextln "Adding existing repo at '\$modulepath' to the index"
282 else
283 die "$(modulepath=$path eval_gettext "'\$modulepath' already exists and is not a valid git repo")"
286 else
288 module_clone "$path" "$realrepo" "$reference" || exit
290 clear_local_git_env
291 cd "$path" &&
292 # ash fails to wordsplit ${branch:+-b "$branch"...}
293 case "$branch" in
294 '') git checkout -f -q ;;
295 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
296 esac
297 ) || die "$(modulepath=$path eval_gettext "Unable to checkout submodule '\$modulepath'")"
299 git config submodule."$path".url "$realrepo"
301 git add $force "$path" ||
302 die "$(modulepath=$path eval_gettext "Failed to add submodule '\$modulepath'")"
304 git config -f .gitmodules submodule."$path".path "$path" &&
305 git config -f .gitmodules submodule."$path".url "$repo" &&
306 git add --force .gitmodules ||
307 die "$(modulepath=$path eval_gettext "Failed to register submodule '\$modulepath'")"
311 # Execute an arbitrary command sequence in each checked out
312 # submodule
314 # $@ = command to execute
316 cmd_foreach()
318 # parse $args after "submodule ... foreach".
319 while test $# -ne 0
321 case "$1" in
322 -q|--quiet)
323 GIT_QUIET=1
325 --recursive)
326 recursive=1
329 usage
332 break
334 esac
335 shift
336 done
338 toplevel=$(pwd)
340 # dup stdin so that it can be restored when running the external
341 # command in the subshell (and a recursive call to this function)
342 exec 3<&0
344 module_list |
345 while read mode sha1 stage path
347 if test -e "$path"/.git
348 then
349 say "$(modulepath=$path eval_gettext "Entering '\$prefix\$modulepath'")"
350 name=$(module_name "$path")
352 prefix="$prefix$path/"
353 clear_local_git_env
354 cd "$path" &&
355 eval "$@" &&
356 if test -n "$recursive"
357 then
358 cmd_foreach "--recursive" "$@"
360 ) <&3 3<&- ||
361 die "$(modulepath=$path eval_gettext "Stopping at '\$modulepath'; script returned non-zero status.")"
363 done
367 # Register submodules in .git/config
369 # $@ = requested paths (default to all)
371 cmd_init()
373 # parse $args after "submodule ... init".
374 while test $# -ne 0
376 case "$1" in
377 -q|--quiet)
378 GIT_QUIET=1
381 shift
382 break
385 usage
388 break
390 esac
391 shift
392 done
394 module_list "$@" |
395 while read mode sha1 stage path
397 # Skip already registered paths
398 name=$(module_name "$path") || exit
399 if test -z "$(git config "submodule.$name.url")"
400 then
401 url=$(git config -f .gitmodules submodule."$name".url)
402 test -z "$url" &&
403 die "$(modulepath=$path eval_gettext "No url found for submodule path '\$modulepath' in .gitmodules")"
405 # Possibly a url relative to parent
406 case "$url" in
407 ./*|../*)
408 url=$(resolve_relative_url "$url") || exit
410 esac
411 git config submodule."$name".url "$url" ||
412 die "$(modulepath=$path eval_gettext "Failed to register url for submodule path '\$modulepath'")"
415 # Copy "update" setting when it is not set yet
416 upd="$(git config -f .gitmodules submodule."$name".update)"
417 test -z "$upd" ||
418 test -n "$(git config submodule."$name".update)" ||
419 git config submodule."$name".update "$upd" ||
420 die "$(modulepath=$path eval_gettext "Failed to register update mode for submodule path '\$modulepath'")"
422 say "$(modulepath=$path eval_gettext "Submodule '\$name' (\$url) registered for path '\$modulepath'")"
423 done
427 # Update each submodule path to correct revision, using clone and checkout as needed
429 # $@ = requested paths (default to all)
431 cmd_update()
433 # parse $args after "submodule ... update".
434 orig_flags=
435 while test $# -ne 0
437 case "$1" in
438 -q|--quiet)
439 GIT_QUIET=1
441 -i|--init)
442 init=1
444 -N|--no-fetch)
445 nofetch=1
447 -f|--force)
448 force=$1
450 -r|--rebase)
451 update="rebase"
453 --reference)
454 case "$2" in '') usage ;; esac
455 reference="--reference=$2"
456 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
457 shift
459 --reference=*)
460 reference="$1"
462 -m|--merge)
463 update="merge"
465 --recursive)
466 recursive=1
468 --checkout)
469 update="checkout"
472 shift
473 break
476 usage
479 break
481 esac
482 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
483 shift
484 done
486 if test -n "$init"
487 then
488 cmd_init "--" "$@" || return
491 cloned_modules=
492 module_list "$@" | {
493 err=
494 while read mode sha1 stage path
496 if test "$stage" = U
497 then
498 echo >&2 "Skipping unmerged submodule $path"
499 continue
501 name=$(module_name "$path") || exit
502 url=$(git config submodule."$name".url)
503 if ! test -z "$update"
504 then
505 update_module=$update
506 else
507 update_module=$(git config submodule."$name".update)
510 if test "$update_module" = "none"
511 then
512 echo "Skipping submodule '$path'"
513 continue
516 if test -z "$url"
517 then
518 # Only mention uninitialized submodules when its
519 # path have been specified
520 test "$#" != "0" &&
521 say "$(modulepath=$path eval_gettext "Submodule path '\$modulepath' not initialized
522 Maybe you want to use 'update --init'?")"
523 continue
526 if ! test -d "$path"/.git -o -f "$path"/.git
527 then
528 module_clone "$path" "$url" "$reference"|| exit
529 cloned_modules="$cloned_modules;$name"
530 subsha1=
531 else
532 subsha1=$(clear_local_git_env; cd "$path" &&
533 git rev-parse --verify HEAD) ||
534 die "$(modulepath=$path eval_gettext "Unable to find current revision in submodule path '\$modulepath'")"
537 if test "$subsha1" != "$sha1"
538 then
539 subforce=$force
540 # If we don't already have a -f flag and the submodule has never been checked out
541 if test -z "$subsha1" -a -z "$force"
542 then
543 subforce="-f"
546 if test -z "$nofetch"
547 then
548 # Run fetch only if $sha1 isn't present or it
549 # is not reachable from a ref.
550 (clear_local_git_env; cd "$path" &&
551 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
552 test -z "$rev") || git-fetch)) ||
553 die "$(modulepath=$path eval_gettext "Unable to fetch in submodule path '\$modulepath'")"
556 # Is this something we just cloned?
557 case ";$cloned_modules;" in
558 *";$name;"*)
559 # then there is no local change to integrate
560 update_module= ;;
561 esac
563 must_die_on_failure=
564 case "$update_module" in
565 rebase)
566 command="git rebase"
567 die_msg="$(modulepath=$path eval_gettext "Unable to rebase '\$sha1' in submodule path '\$modulepath'")"
568 say_msg="$(modulepath=$path eval_gettext "Submodule path '\$modulepath': rebased into '\$sha1'")"
569 must_die_on_failure=yes
571 merge)
572 command="git merge"
573 die_msg="$(modulepath=$path eval_gettext "Unable to merge '\$sha1' in submodule path '\$modulepath'")"
574 say_msg="$(modulepath=$path eval_gettext "Submodule path '\$modulepath': merged in '\$sha1'")"
575 must_die_on_failure=yes
578 command="git checkout $subforce -q"
579 die_msg="$(modulepath=$path eval_gettext "Unable to checkout '\$sha1' in submodule path '\$modulepath'")"
580 say_msg="$(modulepath=$path eval_gettext "Submodule path '\$modulepath': checked out '\$sha1'")"
582 esac
584 if (clear_local_git_env; cd "$path" && $command "$sha1")
585 then
586 say "$say_msg"
587 elif test -n "$must_die_on_failure"
588 then
589 die_with_status 2 "$die_msg"
590 else
591 err="${err};$die_msg"
592 continue
596 if test -n "$recursive"
597 then
598 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
599 res=$?
600 if test $res -gt 0
601 then
602 die_msg="$(modulepath=$path eval_gettext "Failed to recurse into submodule path '\$modulepath'")"
603 if test $res -eq 1
604 then
605 err="${err};$die_msg"
606 continue
607 else
608 die_with_status $res "$die_msg"
612 done
614 if test -n "$err"
615 then
616 OIFS=$IFS
617 IFS=';'
618 for e in $err
620 if test -n "$e"
621 then
622 echo >&2 "$e"
624 done
625 IFS=$OIFS
626 exit 1
631 set_name_rev () {
632 revname=$( (
633 clear_local_git_env
634 cd "$1" && {
635 git describe "$2" 2>/dev/null ||
636 git describe --tags "$2" 2>/dev/null ||
637 git describe --contains "$2" 2>/dev/null ||
638 git describe --all --always "$2"
641 test -z "$revname" || revname=" ($revname)"
644 # Show commit summary for submodules in index or working tree
646 # If '--cached' is given, show summary between index and given commit,
647 # or between working tree and given commit
649 # $@ = [commit (default 'HEAD'),] requested paths (default all)
651 cmd_summary() {
652 summary_limit=-1
653 for_status=
654 diff_cmd=diff-index
656 # parse $args after "submodule ... summary".
657 while test $# -ne 0
659 case "$1" in
660 --cached)
661 cached="$1"
663 --files)
664 files="$1"
666 --for-status)
667 for_status="$1"
669 -n|--summary-limit)
670 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
671 then
673 else
674 usage
676 shift
679 shift
680 break
683 usage
686 break
688 esac
689 shift
690 done
692 test $summary_limit = 0 && return
694 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
695 then
696 head=$rev
697 test $# = 0 || shift
698 elif test -z "$1" -o "$1" = "HEAD"
699 then
700 # before the first commit: compare with an empty tree
701 head=$(git hash-object -w -t tree --stdin </dev/null)
702 test -z "$1" || shift
703 else
704 head="HEAD"
707 if [ -n "$files" ]
708 then
709 test -n "$cached" &&
710 die "$(gettext -- "--cached cannot be used with --files")"
711 diff_cmd=diff-files
712 head=
715 cd_to_toplevel
716 # Get modified modules cared by user
717 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
718 sane_egrep '^:([0-7]* )?160000' |
719 while read mod_src mod_dst sha1_src sha1_dst status name
721 # Always show modules deleted or type-changed (blob<->module)
722 test $status = D -o $status = T && echo "$name" && continue
723 # Also show added or modified modules which are checked out
724 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
725 echo "$name"
726 done
729 test -z "$modules" && return
731 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
732 sane_egrep '^:([0-7]* )?160000' |
733 cut -c2- |
734 while read mod_src mod_dst sha1_src sha1_dst status name
736 if test -z "$cached" &&
737 test $sha1_dst = 0000000000000000000000000000000000000000
738 then
739 case "$mod_dst" in
740 160000)
741 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
743 100644 | 100755 | 120000)
744 sha1_dst=$(git hash-object $name)
746 000000)
747 ;; # removed
749 # unexpected type
750 eval_gettextln "unexpected mode \$mod_dst" >&2
751 continue ;;
752 esac
754 missing_src=
755 missing_dst=
757 test $mod_src = 160000 &&
758 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
759 missing_src=t
761 test $mod_dst = 160000 &&
762 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
763 missing_dst=t
765 total_commits=
766 case "$missing_src,$missing_dst" in
768 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
771 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
773 t,t)
774 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
777 errmsg=
778 total_commits=$(
779 if test $mod_src = 160000 -a $mod_dst = 160000
780 then
781 range="$sha1_src...$sha1_dst"
782 elif test $mod_src = 160000
783 then
784 range=$sha1_src
785 else
786 range=$sha1_dst
788 GIT_DIR="$name/.git" \
789 git rev-list --first-parent $range -- | wc -l
791 total_commits=" ($(($total_commits + 0)))"
793 esac
795 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
796 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
797 if test $status = T
798 then
799 blob="$(gettext "blob")"
800 submodule="$(gettext "submodule")"
801 if test $mod_dst = 160000
802 then
803 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
804 else
805 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
807 else
808 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
810 if test -n "$errmsg"
811 then
812 # Don't give error msg for modification whose dst is not submodule
813 # i.e. deleted or changed to blob
814 test $mod_dst = 160000 && echo "$errmsg"
815 else
816 if test $mod_src = 160000 -a $mod_dst = 160000
817 then
818 limit=
819 test $summary_limit -gt 0 && limit="-$summary_limit"
820 GIT_DIR="$name/.git" \
821 git log $limit --pretty='format: %m %s' \
822 --first-parent $sha1_src...$sha1_dst
823 elif test $mod_dst = 160000
824 then
825 GIT_DIR="$name/.git" \
826 git log --pretty='format: > %s' -1 $sha1_dst
827 else
828 GIT_DIR="$name/.git" \
829 git log --pretty='format: < %s' -1 $sha1_src
831 echo
833 echo
834 done |
835 if test -n "$for_status"; then
836 if [ -n "$files" ]; then
837 status_msg="$(gettextln "# Submodules changed but not updated:")"
838 else
839 status_msg="$(gettextln "# Submodule changes to be committed:")"
841 status_sed=$(sed -e 's|^|# |' -e 's|^# $|#|')
842 cat <<EOF
843 $status_msg
845 $status_sed
847 else
852 # List all submodules, prefixed with:
853 # - submodule not initialized
854 # + different revision checked out
856 # If --cached was specified the revision in the index will be printed
857 # instead of the currently checked out revision.
859 # $@ = requested paths (default to all)
861 cmd_status()
863 # parse $args after "submodule ... status".
864 orig_flags=
865 while test $# -ne 0
867 case "$1" in
868 -q|--quiet)
869 GIT_QUIET=1
871 --cached)
872 cached=1
874 --recursive)
875 recursive=1
878 shift
879 break
882 usage
885 break
887 esac
888 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
889 shift
890 done
892 module_list "$@" |
893 while read mode sha1 stage path
895 name=$(module_name "$path") || exit
896 url=$(git config submodule."$name".url)
897 displaypath="$prefix$path"
898 if test "$stage" = U
899 then
900 say "U$sha1 $displaypath"
901 continue
903 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
904 then
905 say "-$sha1 $displaypath"
906 continue;
908 set_name_rev "$path" "$sha1"
909 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
910 then
911 say " $sha1 $displaypath$revname"
912 else
913 if test -z "$cached"
914 then
915 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
916 set_name_rev "$path" "$sha1"
918 say "+$sha1 $displaypath$revname"
921 if test -n "$recursive"
922 then
924 prefix="$displaypath/"
925 clear_local_git_env
926 cd "$path" &&
927 eval cmd_status "$orig_args"
928 ) ||
929 die "$(modulepath=$path eval_gettext "Failed to recurse into submodule path '\$modulepath'")"
931 done
934 # Sync remote urls for submodules
935 # This makes the value for remote.$remote.url match the value
936 # specified in .gitmodules.
938 cmd_sync()
940 while test $# -ne 0
942 case "$1" in
943 -q|--quiet)
944 GIT_QUIET=1
945 shift
948 shift
949 break
952 usage
955 break
957 esac
958 done
959 cd_to_toplevel
960 module_list "$@" |
961 while read mode sha1 stage path
963 name=$(module_name "$path")
964 url=$(git config -f .gitmodules --get submodule."$name".url)
966 # Possibly a url relative to parent
967 case "$url" in
968 ./*|../*)
969 url=$(resolve_relative_url "$url") || exit
971 esac
973 if git config "submodule.$name.url" >/dev/null 2>/dev/null
974 then
975 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
976 git config submodule."$name".url "$url"
978 if test -e "$path"/.git
979 then
981 clear_local_git_env
982 cd "$path"
983 remote=$(get_default_remote)
984 git config remote."$remote".url "$url"
988 done
991 # This loop parses the command line arguments to find the
992 # subcommand name to dispatch. Parsing of the subcommand specific
993 # options are primarily done by the subcommand implementations.
994 # Subcommand specific options such as --branch and --cached are
995 # parsed here as well, for backward compatibility.
997 while test $# != 0 && test -z "$command"
999 case "$1" in
1000 add | foreach | init | update | status | summary | sync)
1001 command=$1
1003 -q|--quiet)
1004 GIT_QUIET=1
1006 -b|--branch)
1007 case "$2" in
1009 usage
1011 esac
1012 branch="$2"; shift
1014 --cached)
1015 cached="$1"
1018 break
1021 usage
1024 break
1026 esac
1027 shift
1028 done
1030 # No command word defaults to "status"
1031 test -n "$command" || command=status
1033 # "-b branch" is accepted only by "add"
1034 if test -n "$branch" && test "$command" != add
1035 then
1036 usage
1039 # "--cached" is accepted only by "status" and "summary"
1040 if test -n "$cached" && test "$command" != status -a "$command" != summary
1041 then
1042 usage
1045 "cmd_$command" "$@"